<ng-container
  *subscribe="updateRequestDatasetMutation.result$ as requestDataset"
>
  <ngx-loading [show]="requestDataset.isLoading" />
</ng-container>

<ng-container *ngIf="vm$ | async as vm">
  <jds-bi-modal
    id="desk-modal-request-opendata-finish"
    #modal
    [position]="'center'"
  >
    <ng-container ngProjectAs="header">
      <h6>Selesaikan Permohonan Dataset</h6>
      <button
        class="t-button-close"
        (click)="closeModal()"
        role="button"
        type="button"
      >
        <jds-bi-icon
          [size]="14"
          name="xmark"
        />
      </button>
    </ng-container>
    <ng-container ngProjectAs="body">
      <form
        class="form"
        #historyRequestDatasetForm="ngForm"
        [formGroup]="vm.formGroupHistoryRequestDatasetOpenDataFinish"
        (ngSubmit)="onSubmit()"
        (keydown.enter)="$event.stopPropagation()"
      >
        <!-- Sumber Dataset -->
        <div
          *ngrxLet="f.source; let iSource"
          [ngClass]="jds.mb(16)"
        >
          <label [ngClass]="jds.formLabel">
            Sumber Dataset
            <span [ngClass]="jds.text('danger')">*</span>
          </label>
          <div>
            <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
              <input
                [ngClass]="[jds.formCheckInput]"
                (click)="onSelectedSource($event.target.value)"
                value="open_data_jabar"
                type="radio"
                formControlName="source"
              />
              <label [ngClass]="[jds.formCheckLabel]"> Open Data Jabar </label>
            </div>
            <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
              <input
                [ngClass]="[jds.formCheckInput]"
                (click)="onSelectedSource($event.target.value)"
                value="jabar_drive"
                type="radio"
                formControlName="source"
              />
              <label [ngClass]="[jds.formCheckLabel]"> Jabar Drive </label>
            </div>
            <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
              <input
                [ngClass]="[jds.formCheckInput]"
                (click)="onSelectedSource($event.target.value)"
                value="sumber_lain"
                type="radio"
                formControlName="source"
              />
              <label [ngClass]="[jds.formCheckLabel]"> Sumber Lain </label>
            </div>
          </div>
          <ng-container
            *ngIf="iSource?.invalid && (iSource?.dirty || iSource?.touched)"
          >
            <div
              *ngIf="iSource?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
          </ng-container>
        </div>

        <!-- Open Data Jabar -->
        <ng-container *ngIf="f.source.value === 'open_data_jabar'">
          <!-- Link Dataset -->
          <div [ngClass]="jds.mb(16)">
            <label [ngClass]="jds.formLabel">
              Link Dataset <span [ngClass]="jds.text('danger')">*</span>
            </label>

            <ng-container *ngFor="let l of fl.controls; let i = index">
              <ng-container [formGroup]="l">
                <div
                  [ngClass]="[jds.d('flex'), jds.mb(8)]"
                  [style.gap.px]="8"
                >
                  <div [style.flex]="1">
                    <input
                      [colorScheme]="colorScheme"
                      jdsBiInput
                      type="text"
                      placeholder="Masukan tautan disini"
                      formControlName="url"
                    />
                  </div>
                  <div *ngIf="i > 0">
                    <div
                      [ngClass]="[jds.d('flex'), jds.justifyContent('center')]"
                    >
                      <button
                        [colorScheme]="'red'"
                        [isIconOnly]="true"
                        [variant]="'ghost'"
                        (click)="removeLink(i)"
                        jdsBiButton
                        type="button"
                      >
                        <jds-bi-icon
                          size="16"
                          name="trash"
                        />
                      </button>
                    </div>
                  </div>
                </div>
              </ng-container>
            </ng-container>
          </div>

          <div [ngClass]="jds.mb(16)">
            <button
              [ngClass]="[jds.d('flex'), jds.alignItems('center')]"
              [colorScheme]="colorScheme"
              [variant]="'link'"
              (click)="addLink()"
              jdsBiButton
              type="button"
            >
              <jds-bi-icon
                [ngClass]="jds.me(8)"
                name="circle-plus"
              />
              <span>Tambah link dataset</span>
            </button>
          </div>
        </ng-container>

        <!-- Jabar Drive -->
        <ng-container *ngIf="f.source.value === 'jabar_drive'">
          <h6 [ngClass]="[jds.fs(18)]">Metadata</h6>

          <!-- Judul Dataset -->
          <div
            *ngrxLet="f.title; let iTitle"
            [ngClass]="jds.mb(16)"
          >
            <label [ngClass]="jds.formLabel">
              Judul Dataset
              <span [ngClass]="jds.text('danger')">*</span>
            </label>
            <input
              [colorScheme]="colorScheme"
              jdsBiInput
              type="text"
              placeholder="Masukan judul"
              formControlName="title"
            />
            <ng-container
              *ngIf="iTitle?.invalid && (iTitle?.dirty || iTitle?.touched)"
            >
              <div
                *ngIf="iTitle?.errors.required"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Harus diisi
              </div>
              <div
                *ngIf="iTitle?.errors.maxlength"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Panjang maksimal 255 karakter.
              </div>
            </ng-container>
          </div>

          <!-- Link Drive -->
          <div
            *ngrxLet="f.link_drive; let iLinkDrive"
            [ngClass]="jds.mb(16)"
          >
            <label [ngClass]="jds.formLabel">
              Link Drive
              <span [ngClass]="jds.text('danger')">*</span>
            </label>
            <input
              [colorScheme]="colorScheme"
              jdsBiInput
              type="text"
              placeholder="Masukan link"
              formControlName="link_drive"
            />
            <ng-container
              *ngIf="
                iLinkDrive?.invalid &&
                (iLinkDrive?.dirty || iLinkDrive?.touched)
              "
            >
              <div
                *ngIf="iLinkDrive?.errors.required"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Harus diisi
              </div>
            </ng-container>
          </div>

          <!-- Topik -->
          <div
            *ngrxLet="f.topic; let iTopic"
            [ngClass]="jds.mb(16)"
          >
            <label [ngClass]="jds.formLabel">
              Topik <span [ngClass]="jds.text('danger')">*</span>
            </label>
            <ng-container *ngIf="vm.listTopicSatuData as listTopicSatuData">
              <ng-select
                #mapsetTopicSelect
                [items]="
                  listTopicSatuData.isSuccess ? listTopicSatuData.data.list : []
                "
                bindLabel="name"
                placeholder="Pilih topik"
                formControlName="topic"
              />
            </ng-container>
            <ng-container
              *ngIf="iTopic?.invalid && (iTopic?.dirty || iTopic?.touched)"
            >
              <div
                *ngIf="iTopic?.errors.required"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Harus diisi
              </div>
            </ng-container>
          </div>

          <!-- Tahun Produksi -->
          <div
            *ngrxLet="f.year; let iYear"
            [ngClass]="jds.mb(16)"
          >
            <label [ngClass]="jds.formLabel">
              Tahun Produksi <span [ngClass]="jds.text('danger')">*</span>
            </label>
            <ng-container *ngIf="vm.listTopicSatuData as listTopicSatuData">
              <ng-select
                #topicSelect
                [items]="yearOptions"
                placeholder="Pilih tahun"
                formControlName="year"
              />
            </ng-container>
            <ng-container
              *ngIf="iYear?.invalid && (iYear?.dirty || iYear?.touched)"
            >
              <div
                *ngIf="iYear?.errors.required"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Harus diisi
              </div>
            </ng-container>
          </div>

          <!-- Wewenang Pemprov Jabar -->
          <div
            *ngrxLet="f.source; let iSource"
            [ngClass]="jds.mb(16)"
          >
            <label [ngClass]="jds.formLabel">
              Wewenang Pemprov Jabar
              <span [ngClass]="jds.text('danger')">*</span>
            </label>
            <div>
              <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
                <input
                  [ngClass]="[jds.formCheckInput]"
                  (click)="onSelectedAuthority($event.target.value)"
                  value="true"
                  type="radio"
                  formControlName="authority"
                />
                <label [ngClass]="[jds.formCheckLabel]"> Ya </label>
              </div>
              <div [ngClass]="[jds.formCheck, jds.formCheckInline]">
                <input
                  [ngClass]="[jds.formCheckInput]"
                  (click)="onSelectedAuthority($event.target.value)"
                  value="false"
                  type="radio"
                  formControlName="authority"
                />
                <label [ngClass]="[jds.formCheckLabel]"> Tidak </label>
              </div>
            </div>
            <ng-container
              *ngIf="iSource?.invalid && (iSource?.dirty || iSource?.touched)"
            >
              <div
                *ngIf="iSource?.errors.required"
                [ngClass]="[jds.formText, jds.text('danger')]"
              >
                Harus diisi
              </div>
            </ng-container>
          </div>

          <ng-container *ngIf="f.authority.value === 'true'">
            <!-- Alert -->
            <div [ngClass]="[jds.alert, jds.alertPrimary, jds.mb(12)]">
              <div [ngClass]="[jds.d('flex')]">
                <div [ngClass]="jds.alertIcon">
                  <jds-bi-icon
                    [ngClass]="jds.me(8)"
                    name="circle-info"
                  />
                </div>
                <div>
                  Unggah ulang Dataset yang sudah di cleansing dengan click
                  tombol "<strong>Perbarui</strong>" pada Desk Walidata sebelum
                  tanggal {{ getUpdateDate() }}.
                </div>
              </div>
            </div>

            <!-- Produsen -->
            <div
              *ngrxLet="f.organization; let iOrganization"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Produsen <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <ng-container
                *ngIf="vm.listOrganizationSatuData as listOrganizationSatuData"
              >
                <ng-select
                  #mapsetTopicSelect
                  [items]="
                    listOrganizationSatuData.isSuccess
                      ? listOrganizationSatuData.data.list
                      : []
                  "
                  bindLabel="nama_skpd"
                  placeholder="Pilih produsen"
                  formControlName="organization"
                />
              </ng-container>
              <ng-container
                *ngIf="
                  iOrganization?.invalid &&
                  (iOrganization?.dirty || iOrganization?.touched)
                "
              >
                <div
                  *ngIf="iOrganization?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
              </ng-container>
            </div>
          </ng-container>

          <ng-container *ngIf="f.authority.value === 'false'">
            <!-- Nama Organisasi -->
            <div
              *ngrxLet="f.organization_manual; let iOrgManual"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Nama Organisasi
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Masukan nama organisasi"
                formControlName="organization_manual"
              />
              <ng-container
                *ngIf="
                  iOrgManual?.invalid &&
                  (iOrgManual?.dirty || iOrgManual?.touched)
                "
              >
                <div
                  *ngIf="iOrgManual?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="iOrgManual?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>

            <!-- Kontak Organisasi -->
            <div
              *ngrxLet="f.organization_phone; let iOrgPhone"
              [ngClass]="jds.mb(16)"
            >
              <label [ngClass]="jds.formLabel">
                Kontak Organisasi
                <span [ngClass]="jds.text('danger')">*</span>
              </label>
              <input
                [colorScheme]="colorScheme"
                jdsBiInput
                type="text"
                placeholder="Masukan kontak organisasi"
                formControlName="organization_phone"
              />
              <ng-container
                *ngIf="
                  iOrgPhone?.invalid && (iOrgPhone?.dirty || iOrgPhone?.touched)
                "
              >
                <div
                  *ngIf="iOrgPhone?.errors.required"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Harus diisi
                </div>
                <div
                  *ngIf="iOrgPhone?.errors.maxlength"
                  [ngClass]="[jds.formText, jds.text('danger')]"
                >
                  Panjang maksimal 255 karakter.
                </div>
              </ng-container>
            </div>
          </ng-container>
        </ng-container>

        <!-- Catatan Tambahan -->
        <div
          *ngrxLet="f.notes; let iNotes"
          [ngClass]="jds.mb(16)"
        >
          <label [ngClass]="jds.formLabel">
            Catatan Tambahan
            <span [ngClass]="jds.text('danger')">*</span>
          </label>
          <textarea
            [colorScheme]="colorScheme"
            jdsBiInput
            placeholder="Tuliskan disini"
            rows="5"
            formControlName="notes"
          ></textarea>
          <ng-container
            *ngIf="iNotes?.invalid && (iNotes?.dirty || iNotes?.touched)"
          >
            <div
              *ngIf="iNotes?.errors.required"
              [ngClass]="[jds.formText, jds.text('danger')]"
            >
              Harus diisi
            </div>
          </ng-container>
        </div>
      </form>
    </ng-container>
    <ng-container ngProjectAs="footer">
      <div
        [ngClass]="[jds.d('flex')]"
        [style.gap.px]="8"
      >
        <button
          [colorScheme]="'gray'"
          [variant]="'outline'"
          (click)="closeModal()"
          jdsBiButton
          type="button"
        >
          Batal
        </button>
        <button
          [colorScheme]="colorScheme"
          [disabled]="!historyRequestDatasetForm.valid"
          (click)="historyRequestDatasetForm.ngSubmit.emit('Save')"
          jdsBiButton
          type="submit"
        >
          Kirim
        </button>
      </div>
    </ng-container>
  </jds-bi-modal>
</ng-container>
